//#include <MATH.H>
//#include <stdio.h>
//#include <stdlib.h>
#include <PalmOS.h>
#include <PalmCompatibility.h>
#include<Handera/vga.h>
#include "fapfel.h"

#ifdef DEBUG
#define DEBUG_MSG(ValueName,ValueWert) {char	DebugStr7777[16];StrIToA(DebugStr7777,(ValueWert)); FrmCustomAlert( 7777, __PRETTY_FUNCTION__, ValueName, DebugStr7777 );}
#else
#define DEBUG_MSG(ValueName,ValueWert) 
#endif

#define	Unendlich	8.0
#define	Odd(i)		((i&1)==1)
#define FFP		long
//#define max(i,j)	((i)>(j))?(i):(j)

#define TRUE (1)
#define FALSE (0)

// Only every 8 is calculated
#define MAX_SPEED

double	Koords[4]=
{ -0.55, 2.2, -1.35, 1.35 };

BitmapPtr	pBmp[3];
BitmapPtr	pPxl[3];

Boolean		bColor, bUsePxlBmp;
Int16			iMaxColor;

UInt16	MyPattern[4][4]=
{
	{ 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF },
	{ 0x55AA, 0x55AA, 0x55AA, 0x55AA },
	{ 0x4411, 0x4411, 0x4411, 0x4411 },
	{ 0, 0, 0, 0 }
};

FFP	Re_values[328];
FFP	Im_values[328];


// Converts double to FFP with 6 bit integer part ...
FFP	Ftd( double wert )
{
  double	f2;
  long		i2;
  if(  wert>=0.0  )
  	i2 = (double)((long)wert);
  else
  	i2 = -(double)((long)(1-wert));
  f2 = (double)i2;
  return (FFP)(i2<<26l)+(FFP)((wert-f2)*(double)0x4000000ul);
}	// 25.10.00


#if 1
// Multiplies two 26 Fixed Point Floats; returns TRUE, if overflow ...
// using assembler with the normally useless addx.l opcodes ...
extern Boolean	FFPMultiply( FFP wert1, FFP wert2L, FFP *lr );

#else
// Multiplies two 26 Fixed Point Floats; returns TRUE, if overflow ...
Boolean	FFPMultiply( register FFP wert1, register FFP wert2L, FFP *lr )
{
	register unsigned long wert2H=0, resultL=0, resultH=0, sumL;
	int		neg;
	
	neg = 0;
	if(  wert1<0	)	// This work only for positive ints ...
	{
		wert1 = -wert1;
		neg = 1;
	}
	if(  wert2L<0  ) // This work only for positive ints ...
	{
		wert2L = -wert2L;
		neg ^= 1;
	}
	// Swap for less shifts ...
	if(  wert2L>wert1  )
	{
		FFP	temp=wert2L;
		wert2L = wert1;
		wert1 = temp;
	}
	// Now multiply by the "Indian Shift Algorithm"
	while(  wert1!=0ul  )
	{
		if(  wert1&1  )
		{
			// add wert2 to result ...
			resultH += wert2H;
			sumL = resultL+wert2L;
			// overflow?
			if(  sumL<resultL  ||  sumL<wert2L  )
				resultH ++;	// from overflow ...
			resultL += wert2L;
		}
		wert1 >>= 1;
		wert2H += wert2H;	// wert2 *= 2
		// overflow (wieviel leichter ginge es mit ADDX.L ...
		if(  0x80000000ul&wert2L  )
			wert2H ++;
		wert2L += wert2L;
	}
	// Now just look at the significant digits (6 before and 26 after point)
	*lr = ( (resultH<<6) | (resultL>>26) );
	if(  neg&1  )
		*lr = -*lr;
	if(  resultH&0xFC000000ul  )
		return TRUE;	// Overflow ...
	return FALSE;
}
// 24.10.00
#endif

// Macht Apfelmnncheniteration
int	IteriereMandelbrot( register FFP L_real, register FFP L_imag, int Rechentiefe )
{
  FFP	Re, Im, Xx, Yy;
	int	Tiefe;

	Re = L_real;
	Im = L_imag;
	Tiefe = 0;
	
	do
	{
#if 0
		Re >>= 13;
		Im >>= 13;
		
		Xx = Re * Re;		/****  Zahl quadrieren  ****/
		Yy = Im * Im;

		Im = ((Re * Im)<<1) - L_imag;	/****  und dazuaddieren ****/
		Re = Xx - Yy - L_real;
#else
		// True 32 Bits ...
		if(  FFPMultiply( Re, Re, &Xx )  )
			break;	// overflow
		if(  FFPMultiply( Im, Im, &Yy )  )
			break;	// overflow

		if(  Re<Im  )
		{
			if(  FFPMultiply( Re, Im+Im, &Im )  )
				break;	// overflow
			// Im = (Im+Im) - L_imag;
			Im -= L_imag;
		}
		else
		{
			if(  FFPMultiply( Re+Re, Im, &Im )  )
				break;	// overflow
			Im -= L_imag;
		}
		Re = Xx - Yy - L_real;
#endif		
		Tiefe++;
	}
	while(  Tiefe<Rechentiefe  &&  ((Xx+Yy)<0x18000000L)  &&  ((Xx+Yy)>-0x18000000L)  );
	return Tiefe;
}	



int	rechne( int Rechentiefe, double Re_min, double Re_max, double Im_min, double Im_max, int x, int y, int Breit, int Hoch )
{
	EventType e;
  int			xpos, ypos1, ypos2, lx, iTiefe, iTiefe8, iLastTiefe;
  int			iCol, iLastCol=-1, iColFaktor=1;
  int			I_real, I_imag;	// Zaehler
  double	delta;

	if(  iMaxColor>16  )
		iColFaktor = 2;
	if(  iMaxColor>32  )
		iColFaktor = 5;

	// Spiegelebene: Beschleunigung ohen Reue ...
	if(  Im_max<0  ||  Im_min>0  )
	{
		// Es gibt keine Spiegelebene ...
		ypos1 = y;
		ypos2 = y+2*Hoch;
	}
	else
	{
		if(  -Im_min>=Im_max  )
		{	// Most Pixel in negative (upper) part
			ypos1 = y;
			ypos2 = y-2.0*(Hoch*Im_min)/(Im_max-Im_min);
		}
		else
		{	// Most complex: most Pixel are positive ...
			double	fSwap=-Im_max;
			ypos1 = y-(Hoch*(Im_min+Im_max))/(Im_max-Im_min);
			ypos2 = Hoch-1;
			Im_max = -Im_min;
			Im_min = fSwap;
		}
	}
	
  delta = (Im_max-Im_min) / (Hoch-1.0);
  for(  I_imag=0;  I_imag<=Hoch+1;  I_imag++  )
  	Im_values[I_imag] = Ftd( Im_min+delta*(double)I_imag );
	delta = (Re_max-Re_min) / (Breit-1.0);
	for(  I_real=0;  I_real<=Breit+1;  I_real++  )
  	Re_values[I_real] = Ftd( Re_min+delta*(double)I_real );
	
	lx = 1;
	iLastTiefe = -1;
  for(  I_imag=0;  I_imag<=Hoch  &&  ypos1<=ypos2;  I_imag++ )
  {
    xpos = x;

    for(  I_real=0;  I_real<=Breit;  I_real++  )
    {
#ifdef MAX_SPEED
			lx = 1;
			if(  (I_real&7)>0  )
//				iLastTiefe = iTiefe = IteriereMandelbrot( FRe_min+I_real*D_real, FIm_min+I_imag*D_imag, Rechentiefe );
				iLastTiefe = iTiefe = IteriereMandelbrot( Re_values[I_real], Im_values[I_imag], Rechentiefe );
			else
			{
				if(  I_real==0  )
				  iTiefe8 = IteriereMandelbrot( Re_values[I_real], Im_values[I_imag], Rechentiefe );
				iTiefe = iTiefe8;
					iTiefe8 = IteriereMandelbrot( Re_values[I_real+8], Im_values[I_imag], Rechentiefe );
				if(  iTiefe==iTiefe8  &&  iTiefe==iLastTiefe  )
				{
					lx = 8;
					I_real+=7;
				}
				iLastTiefe = iTiefe;
			}
#else
//			iTiefe = IteriereMandelbrot( FRe_min+I_real*D_real, FIm_min+I_imag*D_imag, Rechentiefe );
			iTiefe = IteriereMandelbrot( Re_values[I_real], Im_values[I_imag], Rechentiefe );
#endif
			iCol = (Rechentiefe-iTiefe);
			
			// Plot using gray bitmaps ...
			if(  bUsePxlBmp  )
			{
				if(  (iCol&3)==0  ||  (iCol&3)==3  )
				{
					if(  iCol!=iLastCol  )
						WinSetPattern( (const CustomPatternType *)&(MyPattern[iCol&3][0]) );
					if(  ypos1>=0  )
			    	WinFillLine( xpos, ypos1, xpos+lx, ypos1 );
					if(  ypos2<Hoch  )
				    WinFillLine( xpos, ypos2, xpos+lx, ypos2 );
				}
				else
				if(  (iCol&3)<=2  )
				{
					if(  lx==8  )
						WinDrawBitmap( pBmp[iCol&3], xpos, ypos1 );
					else
						WinDrawBitmap( pPxl[iCol&3], xpos, ypos1 );
					if(  ypos2<Hoch  )
					{
						if(  lx==8  )
							WinDrawBitmap( pBmp[iCol&3], xpos, ypos2 );
						else
							WinDrawBitmap( pPxl[iCol&3], xpos, ypos2 );
					}
				}
			}
			// Grey using patterns
			else if(  iMaxColor==1  )
			{
				if(  iCol!=iLastCol  )
					WinSetPattern( (const CustomPatternType *)&(MyPattern[iCol&3][0]) );
				if(  ypos1>=0  )
		    	WinFillLine( xpos, ypos1, xpos+lx, ypos1 );
				if(  ypos2<Hoch  )
			    WinFillLine( xpos, ypos2, xpos+lx, ypos2 );
			}
			else
			// Or use real colors ...
			{
				if(  iCol!=iLastCol  )
				{
					if(  iCol!=0  )
						WinSetForeColor( (iTiefe*iColFaktor)%224 );
					else
						WinSetForeColor( iMaxColor );
				}
				if(  ypos1>=0  )
			    WinDrawLine( xpos, ypos1, xpos+lx, ypos1 );
				if(  ypos2<Hoch  )
			    WinDrawLine( xpos, ypos2, xpos+lx, ypos2 );
			}
		  iLastCol = iCol;
	
	    xpos += lx;
		}

		EvtGetEvent(&e,0);
		SysHandleEvent(&e);
		if(  e.eType==appStopEvent  )
			return 0;

    ypos1 ++;
    ypos2 --;
  }
  return 1;
}



// **** Main program ****
UInt32 PilotMain (UInt16 cmd, void *cmdPBP, UInt16 launchFlags)
{
	UInt32		il, dh, dw;
	UInt16		err, i, iRechentiefe=30;
	EventType e;
	WinHandle	wh;
	RectangleType rect={{0,0},{160,160}}, mark;

	if(  cmd==sysAppLaunchCmdNormalLaunch  )
	{
		wh = WinCreateWindow( &rect, noFrame, TRUE, TRUE, &err );
		FtrGet( sysFtrCreator, sysFtrNumROMVersion, &il);
		iMaxColor = 1;
		bUsePxlBmp = il<0x03503000;
		if(  bUsePxlBmp  )
		{
			pBmp[1] = MemHandleLock( DmGetResource( 'Tbmp', BmpGray ) );
			pBmp[2] = MemHandleLock( DmGetResource( 'Tbmp', BmpLightGray ) );
			pPxl[1] = MemHandleLock( DmGetResource( 'Tbmp', PxlGray ) );
			pPxl[2] = MemHandleLock( DmGetResource( 'Tbmp', PxlLightGray ) );
		}

#if 1
		// Handera present
		if(  FtrGet(TRGSysFtrID, TRGVgaFtrNum, &il)==0  )
		{
			VgaScreenModeType	sc;
			VgaRotateModeType	rot;
			VgaGetScreenMode( &sc, &rot );
DEBUG_MSG("screenMode",sc);
			VgaSetScreenMode( screenMode1To1, rotateModeNone );
		}
#endif
		WinScreenMode( winScreenModeGet, &dw, &dh, &il, &bColor );
		rect.extent.x = dw;
		rect.extent.y = dh;
DEBUG_MSG("width",dw);
DEBUG_MSG("height",dh);
// Just for Debug
//{
//	char str[20];
//	StrPrintF( str, "%ld %ld $%lx", il, dw, dh );
//	WinDrawChars( str, StrLen(str), 40, 60 );
//}
		WinScreenMode( winScreenModeGetSupportedDepths, NULL, NULL, &il, NULL );
		WinScreenMode( winScreenModeGetSupportsColor, NULL, NULL, NULL, &bColor );
		if(  bColor  )
		{	// Has colors!
			if(  il&8  )
				il = 8;
			else if(  il&128  )
				il = 128;
			else 
				il = 1;
		}
		else
		{	// Grays ...
			if(  il&2  )
				il = 2;
			else if(  il&4  )
				il = 4;
			else if(  il&8  )
				il = 8;
			else
				il = 1;
		}
		bColor = FALSE;
		WinScreenMode( winScreenModeSet, &dw, &dh, &il, &bColor );
DEBUG_MSG("width",dw);
DEBUG_MSG("height",dh);
		iMaxColor = (1<<il)-1;
//		StrPrintF( str, "%i %i %i %i", (int)(Koords[0]*1000.0), (int)(Koords[1]*1000.0), (int)(Koords[2]*1000.0), (int)(Koords[3]*1000.0) );
//		WinDrawChars( str, StrLen(str), 0, 0 );
		rechne( iRechentiefe, Koords[0], Koords[1], Koords[2], Koords[3], rect.topLeft.y, rect.topLeft.y, rect.extent.x, rect.extent.y );
		while(1)
		{
			EvtGetEvent(&e,	-1);

			if (SysHandleEvent(&e))	
				continue;
			if (MenuHandleEvent((void *)0, &e, &err)) 
				continue;
	
			switch (e.eType) 
			{
				case penDownEvent:
					mark.topLeft.x = e.screenX;
					mark.topLeft.y = e.screenY;
					i = 0;
					break;
				
				case penMoveEvent:
					if(  i==1  )
						WinInvertRectangleFrame( simpleFrame, &mark );
					mark.extent.x = e.screenX-mark.topLeft.x;
					mark.extent.y = e.screenY-mark.topLeft.y;
					WinInvertRectangleFrame( simpleFrame, &mark );
					i = 1;
					break;

				case penUpEvent:
					// Mark New Rectangle
					mark.extent.x = e.screenX-mark.topLeft.x;
					mark.extent.y = e.screenY-mark.topLeft.y;
					i = 0;
					if(  mark.extent.x==0  ||  mark.extent.y==0  )
						break;
					if(  mark.extent.x<0  )
					{
						mark.topLeft.x += mark.extent.x;
						mark.extent.x = -mark.extent.x;
					}
					if(  mark.extent.y<0  )
					{
						mark.topLeft.y += mark.extent.y;
						mark.extent.y = -mark.extent.y;
					}
					WinEraseWindow();
					{
						char		str[32];
						double	x1, x2, y1, y2;
						x1=Koords[0]+((double)mark.topLeft.x)*(Koords[1]-Koords[0])/(double)dw;
						x2=((double)mark.extent.x)*(Koords[1]-Koords[0])/(double)dw;
						if(  x2>0  )
						{	// Swap if not left
							Koords[0] = x1;
							Koords[1] = x1+x2;
						}
						else
						{
							Koords[1] = x1;
							Koords[0] = x1+x2;
						}
						y1=Koords[2]+((double)mark.topLeft.y)/(double)dh*(Koords[3]-Koords[2]);
						y2=((double)mark.extent.y)/(double)dh*(Koords[3]-Koords[2]);
						if(  y2>0  )
						{ // Swap for less up
							Koords[2] = y1;
							Koords[3] = y1+y2;
						}
						else
						{
							Koords[3] = y1;
							Koords[2] = y1+y2;
						}
						iRechentiefe = 10.0/(Koords[1]-Koords[0]) + 10.0/(Koords[3]-Koords[2]);
						if(  iRechentiefe<30  )
							iRechentiefe = 30;
						if(  iRechentiefe>512  )
							iRechentiefe = 512;
						StrPrintF( str, "%i: %i %i %i %i", iRechentiefe, (int)(Koords[0]*1000.0), (int)(Koords[1]*1000.0), (int)(Koords[2]*1000.0), (int)(Koords[3]*1000.0) );
						WinDrawChars( str, StrLen(str), 0, 0 );
					}
					if(  rechne( iRechentiefe, Koords[0], Koords[1], Koords[2], Koords[3], rect.topLeft.y, rect.topLeft.y, rect.extent.x, rect.extent.y )==1  )
						break;

				case appStopEvent:
					WinDeleteWindow( wh, TRUE );
					if(  bUsePxlBmp  )
					{
						MemPtrUnlock( pBmp[1] );
						MemPtrUnlock( pBmp[2] );
						MemPtrUnlock( pPxl[1] );
						MemPtrUnlock( pPxl[2] );
					}
					return 0;

			}
		}
	}
	return 0;
}

